=== debian/control ===
Source: lightspark
Section: utils
Priority: optional
Maintainer: Alessandro Pignotti <a.pignotti@sssup.it>
Build-Depends: g++ (>=4.5), cmake, nasm, debhelper (>= 7), libgl1-mesa-dev, libxext-dev, libcurl4-gnutls-dev | libcurl4-openssl-dev, zlib1g-dev, libavcodec-dev, libglew-dev, libcairo2-dev, libjpeg8-dev, libavformat-dev, libswresample-dev, libpango1.0-dev, librtmp-dev, liblzma-dev, libfreetype6-dev, libpng-dev, libsdl2-dev
Standards-Version: 3.8.4
Homepage: http://lightspark.github.io
Vcs-git: git://github.com/lightspark/lightspark.git
Vcs-Browser: https://github.com/lightspark/lightspark

Package: lightspark
Architecture: i386 amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Experimental high-performance SWF (Adobe Flash) player
 Lightspark is a free Flash player for Linux which aims for high-performance
 by using modern technologies such as JIT compilation and OpenGL shaders.
 .
 The project is currently in alpha status, users are invited to test lightspark
 and report any issue
 .
 Nice features:
 * JIT compilation of ActionScript to native x86 bytecode
 * Hardware accelerated rendering using OpenGL shaders (GLSL)
 * Aims to support Actionscript 2 and ActionScript 3
 * A new, clean, codebase exploiting multithreading and optimized for modern
   hardware. Designed from scratch after the official Flash documentation was
   released.

Package: lightspark-common
Architecture: i386 amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Experimental high-performance SWF (Adobe Flash) player
 Lightspark is a free Flash player for Linux which aims for high-performance
 by using modern technologies such as JIT compilation and OpenGL shaders.
 .
 The project is currently in alpha status, users are invited to test lightspark
 and report any issue
 .
 Nice features:
 * JIT compilation of ActionScript to native x86 bytecode
 * Hardware accelerated rendering using OpenGL shaders (GLSL)
 * Aims to support Actionscript 2 and ActionScript 3
 * A new, clean, codebase exploiting multithreading and optimized for modern
   hardware. Designed from scratch after the official Flash documentation was
   released.
 .
 Common library and data

Package: browser-plugin-lightspark
Architecture: i386 amd64
Xb-Npp-Applications: ec8030f7-c20a-464f-9b0e-13a3a9e97384
Xb-Npp-MimeType: application/x-shockwave-flash
Xb-Npp-Name: Lightspark SWF Player
Xb-Npp-Description: High performance SWF Player
Xb-Npp-File: liblightsparkplugin.so
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: gnash
Description: Experimental high-performance SWF (Adobe Flash) player
 Lightspark is a free Flash player for Linux which aims for high-performance
 by using modern technologies such as JIT compilation and OpenGL shaders.
 .
 The project is currently in alpha status, users are invited to test lightspark
 and report any issue
 .
 Nice features:
 * JIT compilation of ActionScript to native x86 bytecode
 * Hardware accelerated rendering using OpenGL shaders (GLSL)
 * Aims to support Actionscript 2 and ActionScript 3
 * A new, clean, codebase exploiting multithreading and optimized for modern
   hardware. Designed from scratch after the official Flash documentation was
   released.
 .
 Mozilla plugin package


Package: lightspark-dbg
Section: debug
Priority: extra
Architecture: i386 amd64
Depends: ${shlibs:Depends}, ${misc:Depends}, 
 lightspark (= ${binary:Version}) |
 browser-plugin-lightspark (= ${binary:Version}) |
 lightspark-common (= ${binary:Version})
Description: High-performance SWF player (experimental) - Debug symbols
 Lightspark is a free Flash player for Linux which aims for high-performance
 by using modern technologies such as JIT compilation and OpenGL shaders.
 .
 The project is currently in alpha status, users are invited to test lightspark
 and report any issue
 .
 Nice features:
 * JIT compilation of ActionScript to native x86 bytecode
 * Hardware accelerated rendering using OpenGL shaders (GLSL)
 * Aims to support Actionscript 2 and ActionScript 3
 * A new, clean, codebase exploiting multithreading and optimized for modern
   hardware. Designed from scratch after the official Flash documentation was
   released.
 .
 This package contains the debug symbols.
